加入收藏 | 设为首页 | 会员中心 | 我要投稿 李大同 (https://www.lidatong.com.cn/)- 科技、建站、经验、云计算、5G、大数据,站长网!
当前位置: 首页 > 大数据 > 正文

02-09 控制AutoCAD环境(九) 访问AutoCAD命令行

发布时间:2020-12-16 22:52:54 所属栏目:大数据 来源:网络整理
导读:Access the AutoCAD Command Line访问AutoCAD命令行 You can send commands directly to the AutoCAD command line by using the SendStringToExecute method. The SendStringToExecute method sends a single string to the command line. The string must

Access the AutoCAD Command Line访问AutoCAD命令行

You can send commands directly to the AutoCAD command line by using the SendStringToExecute method. The SendStringToExecute method sends a single string to the command line. The string must contain the arguments to the command listed in the order expected by the prompt sequence of the executed command.

我们可以使用SendStringToExecute方法直接向AutoCAD命令行发送命令。SendStringToExecute方法将单个字符串发送给命令行。该字符串必须包含按所执行命令的提示序列所期望的顺序排列的命令参数。

A blank space or the ASCII equivalent of a carriage return in the string is equivalent to pressing Enter on the keyboard. Unlike the AutoLISP environment,invoking the SendStringToExecute method with no argument is invalid.

字符串中的空格或代表回车符的ASCII码等同于按下了键盘上的Enter键。和AutoLISP环境不同,调用不带参数的SendStringToExecute方法是非法的。

Commands executed with SendStringToExecute are asynchronous and are not invoked until the .NET command has ended. If you need to execute a command immediately (synchronously),you should:

使用SendStringToExecute方法执行命令是异步的,知道.NET命令结束,所调用的AutoCAD命令才被执行。如果需要立即执行命令(同步),我们应该:

· Use the SendCommand method which is part of the COM Automation library which can be access using .NET COM Interop; 使用.NET COM互操作程序集能访问的COM Automation库的SendCommand方法;

· P/Invoke the unmanaged acedCommand or acedCmd method for native AutoCAD commands and commands defined with the ObjectARX or .NET API; 对于AutoCAD本地命令及由ObjectARX或.NET API定义的命令,使用非托管的acedCommand方法或acedCmd方法;

· P/Invoke the unmanaged acedInvoke method for commands defined through AutoLISP; 对于用AutoLISP定义的命令,使用非托管的acedInvoke方法;

Send a command to the AutoCAD command line 发送名利到AutoCAD命令行

The following example creates a circle with a center of (2,2,0) and a radius of 4. The drawing is then zoomed to all the geometry in the drawing. Notice that there is a space at the end of the string which represents the final Enter to begin execution of the command.

下面的例子用圆心(2,2,0)和半径4创建一个圆,然后将图形缩放到全部图形都可见。注意字符串结尾有一个空格,代表最后按Enter键开始执行命令。

VB.NET

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.Runtime

<CommandMethod("SendACommandToAutoCAD")> _

Public Sub SendACommandToAutoCAD()

Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

'' Draws a circle and zooms to the extents or

'' limits of the drawing

acDoc.SendStringToExecute("._circle 2,0 4 ",True,False,False)

acDoc.SendStringToExecute("._zoom _all ",False)

End Sub

C#

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.Runtime;

[CommandMethod("SendACommandToAutoCAD")]

public static void SendACommandToAutoCAD()

{

Document acDoc = Application.DocumentManager.MdiActiveDocument;

// Draws a circle and zooms to the extents or limits of the drawing

//画圆并缩放到图形界限

acDoc.SendStringToExecute("._circle 2,true,false,false);

acDoc.SendStringToExecute("._zoom _all ",false);

}

VBA/ActiveX Code Reference

Sub SendACommandToAutoCAD()

' Draws a circle and zooms to the extents or

' limits of the drawing

ThisDrawing.SendCommand "_Circle 2,0 4 "

ThisDrawing.SendCommand "_zoom a "

End Sub

译者:到此,《控制AutoCAD环境》这一章就翻译完了,接下来的一章是《创建和编辑AutoCAD实体(图元)》,敬请期待!

(编辑:李大同)

【声明】本站内容均来自网络,其相关言论仅代表作者个人观点,不代表本站立场。若无意侵犯到您的权利,请及时与联系站长删除相关内容!

    推荐文章
      热点阅读